# Outline

1. Greedy Search:
    - How to generate text with greedy decoding?
    - What are the pitfalls of greedy decoding?
2. Beam search:
    - How to consider hidden high probability word sequences?
    - What are some problems with beam search decoding?
3. Nucleus (Top-$p$) sampling:
    - How to leverage stochastic generation to avoid repetitive generation?
4. Evaluation of generated text:
    - How to evaluate generated text without explicit labels?
    - What are the pitfalls of scores like BLEU?
5. Story generation (Optional)

### ⚠️ **Note: You do not need to execute any cells. It will take a little while to do so. But feel free to explore different sentences as well.** ⚠️

### Acknowledgements

We are very grateful to [Patrick von Platen](https://huggingface.co/patrickvonplaten) for writing a [blogpost on different generation techniques](https://huggingface.co/blog/how-to-generate). Our notebook takes its examples, images, and wordings. Moreover, we would like to thank [Google Cloud Translation's evaluation documentation](https://cloud.google.com/translate/automl/docs/evaluate#:~:text=BLEU%20(BiLingual%20Evaluation%20Understudy)%20is,of%20high%20quality%20reference%20translations), which we have used for the evaluation section. We encourage you to check these resources out!

---

Made by Bayazit Deniz <deniz.bayazit@epfl.ch>, Dec. 2022.
